/*This is the demo file. Read the top of Icon Focus.dm for a more in
depth explination. This mainly shows how you can use this.*/



//******************************************************************
//Part 1 - Holding a Sword in different hands.
//******************************************************************
mob
	Player
		icon = 'Icons.dmi'
		icon_state = "Player"
		InitializeFocus()
			Focus += list("RHandx" = 10 , "LHandx" = 20 , \
			"Handx" = 10 , "Handy" = 11)
			return ..()
	Login() { ..() ; PickHand() }
	verb
		PickHand()
			var
				icon/I = icon('Icons.dmi',"Sword")
				Hand = alert("What hand do you use?","Hand","R","L")
			Focus(I , IconFocus["Swordx"] , IconFocus["Swordy"] , \
			Focus["[Hand]Handx"] , Focus["Handy"])
			Images += I ; FocusedImages(dir)



//******************************************************************
//Part 2 - Having different types have the icon in different places.
//******************************************************************
mob
	Things
		icon = 'Icons.dmi'
		Golem
			icon_state = "Golem"

			InitializeFocus()
				Focus += list("Handx" = 8 , "Handy" = 8); return ..()
		Soldier
			icon_state = "Soldier"
			InitializeFocus()
				Focus += list("Handx" = 22 , "Handy" = 10); return ..()
world
	New()
		for(var/turf/T in world)
			if(prob(5))
				var/P = pick("/mob/Things/Golem","/mob/Things/Soldier")
				var/mob/M = new P
				M.Move(T) ; walk_rand(M,13)
				var/icon/I = icon('Icons.dmi',"RedSword")
				Focus(I , IconFocus["Swordx"] , IconFocus["Swordy"] , \
				M.Focus["Handx"] , M.Focus["Handy"])
				M.Images += I
		return ..()

//******************************************************************
//World Initialization.
//******************************************************************

world
	mob = /mob/Player
	New()
		IconFocus += list("Swordx" = 2 , "Swordy" = 2 , \
			"Applex" = 3 , "Appley" = 5)
		for(var/turf/T in world)
			if(prob(20)) {new/turf/Apple_Tree(T)}
		return ..()



//******************************************************************
//Part 3 - Apple Trees.
//******************************************************************
turf
	Grass
		icon = 'Icons.dmi'
		icon_state = "Grass"
	Apple_Tree
		icon = 'Icons.dmi'
		icon_state = "AppleTree"
		density = 1
		New()
			var
				num = rand(1,3) ; usedx[0] ; usedy[0]
				icon/B = icon('Icons.dmi',"AppleTree")
			while(num)
				var
					xx = rand(13,20) ; yy = rand(9,20)
					icon/A = icon('Icons.dmi',"Apple")
				if(!(xx in usedx) && !(yy in usedy))
					Focus(A,IconFocus["Applex"],IconFocus["Appley"],\
					xx , yy)
					B.Blend(A,ICON_OVERLAY)
					usedx += list(xx+1 , xx , xx-1)
					usedy += list(yy+1 , yy , yy-1)
					num--
			icon = B ; return ..()


//******************************************************************
//Part 4 - Custom Sparks.
//******************************************************************
mob/Stat()
	statpanel("Info:")
	stat("CPU%:","[world.cpu]%")
	stat("Total Sparks Created:","[sparkscreated] Sparks")
	if(prob(30))
		var/turf/A = locate(rand(1,world.maxx),\
		rand(1,world.maxy),1)
		if(A)
			spawn(rand(1,5))
				Spark(100 , A , A.Focus["Center"]\
			 	, A.Focus["Center"])
			spawn(rand(6,9))
				Spark(100 , A , A.Focus["Center"]\
			 	, A.Focus["Center"] , 0)
	return ..()

client/Click(atom/A)
	spawn(rand(1,5))
		Spark(100 , A , A.Focus["Center"]\
	 	, A.Focus["Center"])
	spawn(rand(6,9))
		Spark(100 , A , A.Focus["Center"]\
	 	, A.Focus["Center"] , 0)
	return ..()

atom
	InitializeFocus()
		Focus += list("Center" = 16) ; return ..()

proc
	Spark( Amount = 1 , datum/Location , X = 1 , Y = 1 , White = 1)
		if( !Location ) return null
		var
			Icons[0]
			Ra = rand(4,7)
		if(White)
			var/obj/O = new()
			O.icon = pick(Explosions)
			O.loc = locate(Location:x,Location:y,Location:z)
			spawn(2) del O
		for(var/r = 1 to Ra)
			var
				icon/I = icon('Icons.dmi',"Spark")
				R = rand(204,255) ; G = rand(204,255)
				B = rand(104,204)
			I.Blend( rgb(R,G,B) )
			Focus( I , 2 , 2 , X , Y ) ; Icons += I
		for(var/a = 1 to Amount)
			var
				obj/Spark/S = new()
				icon/I = pick(Icons)
			S.loc = locate(Location:x,Location:y,Location:z)
			S.icon = I ; spawn(1) S.Spark()
		sparkscreated += Amount

var/sparkscreated = 0

obj
	Spark
		icon = 'Icons.dmi'
		icon_state = "Spark"
	InitializeFocus()
		Focus += list("Sparkx" = 16 , "Sparky" = 16) ; return ..()

	proc
		Spark()
			set background = 1
			var
				Horizontal = pick(-2,-1,0,0,1,2)
				Vertical = pick(-2,-1,0,0,1,2)
				Move = 14
			if( !Horizontal && !Vertical)
				if(prob(50)) Horizontal += pick(-1,1)
				else Vertical += pick(-1,1)
			while( src && Move )
				var
					Lastx	= Focus["Sparkx"]
					Lasty	= Focus["Sparky"]
					Newx	= Lastx + Horizontal
					Newy	= Lasty + Vertical
					icon/I	= new(icon)
				Focus( I , Lastx , Lasty , Newx , Newy )
				Focus["Sparkx"] = Newx ; Focus["Sparky"] = Newy
				icon = I
				sleep(rand(0.5,1.5))
				Move -= max(Horizontal,Vertical)
				if(prob(20)) del src
			del src

world/New()
	spawn()
		Explosions = new/list
		var/R = rand(1,5)
		for(var/a = 1 to R)
			var/icon/I = icon('Icons.dmi',"Spark")
			for(var/b = 1 to 32)
				for(var/c = 1 to 32)
					var/B = rand(104,204) , RG = rand(200,255)
					I.DrawBox(rgb(RG,RG,B),b,c)
			Explosions += I
	return ..()

var/Explosions[0]

//******************************************************************
//Part 5 - Other.
//******************************************************************
mob/New()
	var/obj/O = new() , icon/I = icon('Icons.dmi',"Dir") ; O.layer = 30
	Focus(I , 1 , 1 , Focus["Handx"] , Focus["Handy"])
	O.IsDirSpecific = TRUE ; O.icon = I ; Images += O ; return ..()

client/Click(atom/A)
	if(ismob(A))
		var/mob/M = A
		world<<"[M]'s hand is at [M.Focus["Handx"]],[M.Focus["Handy"]]"